// CopySpdBench.cpp : R\[ AvP[ṼGg |Cg`܂B
//
// MyDiskTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//
#include "stdafx.h"

#include <windows.h>
#include <time.h>
#include <conio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <vector>
#include <map>
#include <algorithm>

#pragma comment(lib,"winmm.lib")

using namespace std;

BOOL DeleteDirectory( LPCTSTR lpPathName )
{
	// ͒l`FbN
	if( NULL == lpPathName )
	{
		return FALSE;
	}

	// fBNg̕ۑiI['\'ȂȂtj
	TCHAR szDirectoryPathName[_MAX_PATH];
	_tcsncpy_s( szDirectoryPathName, _MAX_PATH, lpPathName, _TRUNCATE );
	if( '\\' != szDirectoryPathName[_tcslen(szDirectoryPathName) - 1] )
	{	// ԍŌ'\'ȂȂtB
		_tcsncat_s( szDirectoryPathName, _MAX_PATH, _T("\\"), _TRUNCATE );
	}

	// fBNg̃t@Cp̃t@C쐬
	TCHAR szFindFilePathName[_MAX_PATH];
	_tcsncpy_s( szFindFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
	_tcsncat_s( szFindFilePathName, _MAX_PATH, _T("*"), _TRUNCATE );

	// fBNg̃t@CJn
	WIN32_FIND_DATA		fd;
	HANDLE hFind = FindFirstFile( szFindFilePathName, &fd );
	if( INVALID_HANDLE_VALUE == hFind )
	{	// ΏۃtH_݂ȂB
		return FALSE;
	}

	do
	{
		if( '.' != fd.cFileName[0] )
		{
			TCHAR szFoundFilePathName[_MAX_PATH];
			_tcsncpy_s( szFoundFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
			_tcsncat_s( szFoundFilePathName, _MAX_PATH, fd.cFileName, _TRUNCATE );

			if( FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes )
			{	// fBNgȂċNĂяoō폜
				if( !DeleteDirectory( szFoundFilePathName ) )
				{
					return FALSE;
				}
			}
			else
			{	// t@CȂWin32API֐pč폜
				if( !DeleteFile( szFoundFilePathName ) )
				{
					return FALSE;
				}
			}
		}
	} while( FindNextFile( hFind, &fd ) );

	FindClose( hFind );

	return RemoveDirectory( lpPathName );
}

//nFileSizeKBP
bool Init(const string& rsHeader, long long nFileSize, int nFileNum)
{
	BOOL result;
	int BufSize = 1024*1024; //1MB

	char *buf = new char[BufSize];
	char sFileNameFrom[100];

	long long nLoopNum = nFileSize/1024;
	DWORD nAmari = (DWORD)(nFileSize%1024);

	for (int j=0; j<nFileNum; ++j) {
		int temp = BufSize / 2;
		if (nLoopNum == 0) temp = nAmari*1024/2;
		for(int i=0;i< temp;i++){
			memset((buf + i*2), rand(), 2);
		}
		sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s\\test%d.dat", rsHeader.c_str(), j);
		HANDLE hFile = ::CreateFile(sFileNameFrom, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

		if(hFile == INVALID_HANDLE_VALUE){
			cout << " CreateFile Error:INVALID_HANDLE_VALUE" << endl;
			delete [] buf;
			return false;
		}
		USHORT lpInBuffer = COMPRESSION_FORMAT_NONE;
		DWORD lpBytesReturned = 0;
		DeviceIoControl(hFile, FSCTL_SET_COMPRESSION, (LPVOID) &lpInBuffer,
					sizeof(USHORT), NULL, 0, (LPDWORD)&lpBytesReturned, NULL);
		DWORD writesize;
		for(long long i = 0;i < nLoopNum; ++i){
			result = WriteFile(hFile, buf, BufSize, &writesize, NULL);
			if(result == 0){
				cout << " WriteFile Error" << endl;
				delete[] buf;
				CloseHandle(hFile);
				return false;
			}
		}
		if ((nAmari != 0) && (WriteFile(hFile, buf, nAmari*1024, &writesize, NULL) == 0)){
			cout << " WriteFile Error" << endl;
			delete[] buf;
			CloseHandle(hFile);
			return false;
		}
		FlushFileBuffers(hFile);
		CloseHandle(hFile);
	}
	delete[] buf;
	return true;
}

DWORD CopyTest(const string& rDrive, long long nFileSize, int nFileNum) {

	char sFileNameFrom[100];
	char sFileNameTo[100];
	char sDirectoryName[100];

	cout << "Preparing...";
	sprintf_s(sDirectoryName, sizeof(sDirectoryName), "%s\\CopySpdBench%d", rDrive.c_str(), (unsigned int)time(0)); 

	if (CreateDirectory(sDirectoryName, NULL) && Init(sDirectoryName, nFileSize, nFileNum)) {
		cout << " Testing...";
		DWORD First = timeGetTime();
		for (int i=0; i<nFileNum; ++i) {
			sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s\\test%d.dat", sDirectoryName, i);	
			sprintf_s(sFileNameTo, sizeof(sFileNameTo), "%s\\copy%d.dat", sDirectoryName, i);
			if (!CopyFile(sFileNameFrom, sFileNameTo, FALSE)) {
				cout << "Copy Failed!" << endl;
				return 0;
			}
		}
		DWORD Last = timeGetTime();
		DeleteDirectory(sDirectoryName);
		cout << " Done.";
		return Last-First;
	}
	else {
		cout << "Init Failed" << endl;
		return 0;
	}
}


DWORD CopyTestLow(const string& rDrive, long long nFileSize, int nFileNum, long long nBufSizeKB) {

	char sFileNameFrom[100];
	char sFileNameTo[100];
	char sDirectoryName[100];

	cout << "Preparing...";
	sprintf_s(sDirectoryName, sizeof(sDirectoryName), "%s\\CopySpdBench%d", rDrive.c_str(), (unsigned int)time(0));

	DWORD nBufSize = (DWORD)nBufSizeKB*1024;
	long long nTimes = nFileSize/nBufSizeKB;
	long long nAmariKB = nFileSize%nBufSizeKB;
	DWORD nAmari = (DWORD)nAmariKB*1024;
	char *pBuf = new char[(size_t)nBufSize];
	if (CreateDirectory(sDirectoryName, NULL) && Init(sDirectoryName, nFileSize, nFileNum)) {
		vector<HANDLE> vFromFiles;
		vector<HANDLE> vToFiles;

		cout << " Testing...";
		DWORD First = timeGetTime();
		for (int i=0; i<nFileNum; ++i) {
			sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s\\test%d.dat", sDirectoryName, i);	
			sprintf_s(sFileNameTo, sizeof(sFileNameTo), "%s\\copy%d.dat", sDirectoryName, i);
			HANDLE hFileFrom = ::CreateFile(sFileNameFrom, GENERIC_READ, 0, NULL, OPEN_EXISTING,
													 FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);
			if (hFileFrom == INVALID_HANDLE_VALUE) {
				cout << "open from failed" << endl;
				delete[] pBuf;
				return 0;
			}
			HANDLE hFileTo = ::CreateFile(sFileNameTo, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
													 FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);
			if (hFileTo == INVALID_HANDLE_VALUE) {
				cout << "open to failed" << endl;
				delete[] pBuf;
				return 0;
			}
			vFromFiles.push_back(hFileFrom);
			vToFiles.push_back(hFileTo);
		}
		DWORD Second = timeGetTime();
		for (int i=0; i<nFileNum; ++i) {
			HANDLE& hFileFrom = vFromFiles[i];
			HANDLE& hFileTo = vToFiles[i];
			DWORD nRead;
			for (long long j=0; j<nTimes; ++j) {
				if ((!ReadFile(hFileFrom, (LPVOID)pBuf, (DWORD)nBufSize, &nRead, NULL)) || (!WriteFile(hFileTo, (LPVOID)pBuf, (DWORD)nBufSize, &nRead, NULL))) {
					cout << "copy failed" << endl;
					delete [] pBuf;
					return 0;
				}
			}
			if ((!ReadFile(hFileFrom, (LPVOID)pBuf, nAmari, &nRead, NULL)) || (!WriteFile(hFileTo, (LPVOID)pBuf, nAmari, &nRead, NULL))) {
				cout << "copy failed" << endl;
				delete [] pBuf;
				return 0;
			}
			FlushFileBuffers(hFileTo);
		}

		DWORD Third = timeGetTime();	
		for (int i=0; i<nFileNum; ++i) {
			CloseHandle(vFromFiles[i]);
			CloseHandle(vToFiles[i]);
		}
		DWORD Last = timeGetTime();

		DeleteDirectory(sDirectoryName);
		cout << " Done.";
		delete[] pBuf;
//		return Last-First;
		return Third-Second;
	}
	else {
		cout << "Init Failed" << endl;
		delete[] pBuf;
		return 0;
	}
}

//t@CTCYǂݎ
long long GetFileSizeFromString(const string& sFileSize) {
	char cType = sFileSize[sFileSize.length()-1];
	if ((cType == 'k') || (cType == 'K')) {
		return (long long)(atof(sFileSize.c_str()));
	}
	else if ((cType == 'm') || (cType == 'M')) {
		return (long long)(atof(sFileSize.c_str())*1024);
	}
	else if ((cType == 'g') || (cType == 'G')) {
		return (long long)(atof(sFileSize.c_str())*1024*1024);
	}
	else {
		return 0;
	}
}

bool CopyBench(bool bHighLevel, const string& sDrive, const string& sFileSize, int nFileNum, int nTrial, const string& sBufSize, ostream &outResult) {

	//fBXN擾
	static map<string, long long>  _mAlreadyCheckedDrive;
	long long nFreeByte;
	map<string, long long>::const_iterator itDrive = _mAlreadyCheckedDrive.find(sDrive);
	if (itDrive == _mAlreadyCheckedDrive.end()) {
		DWORD SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters;
		if (GetDiskFreeSpace(sDrive.c_str(), &SectorsPerCluster, &BytesPerSector, &NumberOfFreeClusters, &TotalNumberOfClusters)) {
			nFreeByte = (long long)NumberOfFreeClusters*SectorsPerCluster*BytesPerSector/1024;
			long long nTotalByte = (long long)TotalNumberOfClusters*SectorsPerCluster*BytesPerSector/1024;
			cout << "Disk " << sDrive << " Capacity: Total=" << nTotalByte/1024.0/1024.0 << "[GB] Free=" << nFreeByte/1024.0/1024.0 << "[GB]" << endl;
			outResult << "Disk " << sDrive << " Capacity: Total=" << nTotalByte/1024.0/1024.0 << "[GB] Free=" << nFreeByte/1024.0/1024.0 << "[GB]" <<  "\r\n";
			_mAlreadyCheckedDrive.insert(make_pair(sDrive, nFreeByte));
		}
		else {
			cout << "Could not Get the Drive Information of " << sDrive << endl;
			return false;
		}
	}
	else {
		nFreeByte = itDrive->second;
	}

	long long nFileSize = GetFileSizeFromString(sFileSize);
	if (nFileSize == 0) {
		cout << "Size Type Must Be \'K\' or \'M\' or \'G\'." << endl;
		return false;
	}
	long long nBufSize = 0;
	if (!bHighLevel) {
		nBufSize = GetFileSizeFromString(sBufSize);
		if (nBufSize == 0) {
			cout << "Size Type Must Be \'K\' or \'M\' or \'G\'." << endl;
			return false;
		}
	}
	if (nFileSize*nFileNum*2 > nFreeByte) {
		cout << "Error: Free Space is NOT Enough." << endl;
		return false;
	}

	//Rs[eXg
	if (bHighLevel) {
		cout << "HL "<< sDrive << " " << sFileSize << " " << nFileNum << "File(s) " << nTrial << "Trial(s)" << endl;
		outResult << "HL " << sDrive << setw(5) << sFileSize << " "  << setw(4) << nFileNum << "File(s) " << setw(2)  << nTrial << "Trial(s) : " ;
	}
	else {
		cout << "LL "<< sDrive << " " << sFileSize << " (Buffer:" << sBufSize << ") " << nFileNum << "File(s) " << nTrial << "Trial(s)" << endl;
		outResult << "LL "<< sDrive <<  setw(5) << sFileSize << " (Buffer:"  << setw(4) << sBufSize << ") "  << setw(4) << nFileNum << "File(s) "  << setw(2) << nTrial << "Trial(s) : " ;
	}
	double res;
	double resMB;
	double resTotal = 0;
	int nSucceeded = 0;
	for (int i=0; i<nTrial; ++i) {
		cout << "[Trial " << i << "] ";
		if (bHighLevel)
			res = CopyTest(sDrive, nFileSize, nFileNum) / 1000.0;
		else 
			res = CopyTestLow(sDrive, nFileSize, nFileNum, nBufSize) / 1000.0;
		if (res != 0) {
			resMB = (nFileSize/1024.0*nFileNum) / res;
			cout << "  Result: " << setw(7) << resMB << "[MB/s] ("  << res << "[sec])" << endl; 
			resTotal += res;
			++nSucceeded;
		}
	}
	if (nSucceeded > 0) {
		double dResult = (nFileSize/1024.0*nFileNum*nSucceeded)/resTotal;
		double dResultSec = resTotal/nSucceeded;
		cout << "Average:" << setw(7) << dResult << "[MB/s] (" << setw(7)  << dResultSec << "[sec])" << endl;
		outResult << "Average:" << setw(7)  << dResult << "[MB/s] (" << setw(7) << dResultSec << "[sec])" << "\r\n";
		return true;
	}
	else return false;
}


string GetOSVersion() {

	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (GetVersionEx (&osvi)) {
		if (osvi.dwMajorVersion == 4) {
			if (osvi.dwMinorVersion == 0) return "Windows 95";
			else if (osvi.dwMinorVersion == 10) return "Windows 98";
			else if (osvi.dwMinorVersion == 90) return "Windows ME";
			else return "Unknown";
		}
		else if (osvi.dwMajorVersion == 5) {
			if (osvi.dwMinorVersion == 0) return "Windows 2000";
			else if (osvi.dwMinorVersion == 1) return "Windows XP (32bit)";
			else if (osvi.dwMinorVersion == 2) return "Windows XP (64bit)";
			else return "Unknown";
		}
		else if (osvi.dwMajorVersion == 6) {
			if (osvi.dwMinorVersion == 0) {
				char sTemp[200];
				if (GetSystemWow64Directory(sTemp, 200)) return "Windows Vista (64bit)";
				else return "Windows Vista (32bit)";
			}
			else return "Unknown";
		}
		else return "Unknown";
	}
	return "";
}
void main()
{
	srand((unsigned int)time(0));
	ostringstream oss;
	cout << "CopySpdBench Build: [" << __TIMESTAMP__ << "]" << endl;
	oss << "CopySpdBench Build: [" << __TIMESTAMP__ << "]" << "\r\n";

	string sOS = GetOSVersion();
	if (sOS == "") {
		cout << "Cound NOT Get OS Version. " << endl;
		return ;
	}
	cout << "OS: " << sOS << endl;
	oss << "OS: " << sOS << "\r\n";

	ifstream ifs("CopySpdBench.ini");
	if (ifs) {
		cout << setprecision(3) << fixed;
		oss << setprecision(3) << fixed;
		string line;
		while (getline(ifs, line)) {
			if ( !line.empty() && (line[0] != '#')) {
				char sFileSize[100], sDrive[100], sBufSize[100], sMode[100];
				int nFileNum, nTrial;
				if ((line[0] == 'H') && (line[1] == 'L')) {
					int nRes = sscanf_s(line.c_str(), "%s %s %s %d %d\n", sMode, sizeof(sMode), sDrive, sizeof(sDrive), sFileSize, sizeof(sFileSize), 
															&nFileNum, &nTrial);
					if (nRes == 5)  CopyBench(true, sDrive, sFileSize, nFileNum, nTrial, "", oss);
					else cout << "ini error: " << line << endl;
				}
				else if ((line[0] == 'L') && (line[1] == 'L')) {
					int nRes = sscanf_s(line.c_str(), "%s %s %s %s %d %d\n", sMode, sizeof(sMode), sDrive, sizeof(sDrive), sFileSize, sizeof(sFileSize), 
															sBufSize, sizeof(sBufSize), &nFileNum, &nTrial);
					if (nRes == 6)  CopyBench(false, sDrive, sFileSize, nFileNum, nTrial, sBufSize, oss);
					else cout << "ini error: " << line << endl;
				}
				else cout << "ini error: " << line << endl;
			}
		}
	}
	else {
		cout << "CopySpdBench.ini NOT Found." << endl;
		CopyBench(true, "C:", "4K", 1000, 5, "", oss);
	}
	ofstream ofs("result.txt");
	ofs << oss.str() << flush;

	cout << "Press Any Key to Finish." << endl;
	cout << "(To Copy the Result to the Clipboard, Press 'c'.)" << endl;
	if (_getch() == 'c') {
		if (OpenClipboard(NULL)) {
			HGLOBAL hText = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE, oss.str().length()+1);
			char* pText = (char*)GlobalLock(hText);
			lstrcpy(pText, oss.str().c_str());
			GlobalUnlock(hText);
			EmptyClipboard();
			SetClipboardData(CF_TEXT, hText);
			CloseClipboard();
			GlobalFree(hText);
		}
	}
}